Bug 1490057 - Review Request: cloudcompare - 3D point cloud and mesh processing software
Summary: Review Request: cloudcompare - 3D point cloud and mesh processing software
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-09-09 18:22 UTC by Miro Hrončok
Modified: 2018-03-06 17:24 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-03-06 17:24:40 UTC
Type: ---
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Miro Hrončok 2017-09-09 18:22:49 UTC
Spec URL: https://churchyard.fedorapeople.org/SRPMS/cloudcompare.spec
SRPM URL: https://churchyard.fedorapeople.org/SRPMS/cloudcompare-2.8.1-1.fc26.src.rpm

Description:

CloudCompare is a 3D point cloud (and triangular mesh) processing software.
It has been originally designed to perform comparison between two 3D points
clouds (such as the ones obtained with a laser scanner) or between a point
cloud and a triangular mesh.
It relies on a specific octree structure that enables great performances in
this particular function. It was also meant to deal with huge point clouds
(typically more than 10 millions points, and up to 120 millions with 2 Gb of
memory).

Afterwards, it has been extended to a more generic point cloud processing
software, including many advanced algorithms (registration, resampling,
color/normal/scalar fields handling, statistics computation, sensor
management, interactive or automatic segmentation, display enhancement...).

Fedora Account System Username: churchyard


Note that this is still very raw package, I'm opening this Review Request to gather general feedback and to inform others I'm working on it.

Comment 1 Robert-André Mauchin 🐧 2017-09-11 11:41:08 UTC
Hello,

 - You can use these URL as SourceX:

Source0:        https://github.com/%{cname}/%{cname}/archive/v%{version}/%{cname}-%{version}.tar.gz

# git submodules
%global pr_commit 7ad96383f639d7625a843c6e97b3ae5579507350
Source1:        https://github.com/%{cname}/PoissonRecon/archive/%{pr_commit}/PoissonRecon-%{pr_commit}.tar.gz

%global nh_commit 61ba8056d72eedffadb838d9051cc8975ec7a825
Source2:        https://github.com/%{cname}/normals_Hough/archive/%{nh_commit}/normals_Hough-%{nh_commit}.tar.gz

 - You should use the %make_install macro instead of make DESTDIR=%{buildroot} install %{?_smp_mflags}

 - Similarly use %make_build instead of make %{?_smp_mflags}

 - The documentation is rather big, it should go in a -doc subpackage.

 - Since you are installing icons into hicolor, you must add:

Requires:       hicolor-icon-theme
 
 for directory ownership.

  - Package fails to build on multiple architectures: https://koji.fedoraproject.org/koji/taskinfo?taskID=21793708



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Large documentation must go in a -doc subpackage. Large could be size
  (~1MB) or number of files.
  Note: Documentation size is 15974400 bytes in 5 files.
  See:
  http://fedoraproject.org/wiki/Packaging/Guidelines#PackageDocumentation


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "LGPL (v2 or later)", "GPL (v2 or later)", "GPL (v3 or later)",
     "Unknown or generated", "MIT/X11 (BSD like)", "Apache (v1.1)",
     "zlib/libpng", "LGPL", "GPL (v2) LGPL (v2 or later)", "BSD
     (unspecified)", "BSD (2 clause)", "LGPL (v2.1 or later)", "GPL (v2)".
     834 files have unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/cloudcompare/review-
     cloudcompare/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[!]: Package must own all directories that it creates.
     Note: Directories without known owners:
     /usr/share/icons/hicolor/256x256/apps,
     /usr/share/icons/hicolor/64x64/apps,
     /usr/share/icons/hicolor/32x32/apps,
     /usr/share/icons/hicolor/16x16/apps, /usr/share/icons/hicolor/16x16,
     /usr/share/icons/hicolor/64x64, /usr/share/icons/hicolor/256x256,
     /usr/share/icons/hicolor, /usr/share/icons/hicolor/32x32
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: update-desktop-database is invoked in %post and %postun if package
     contains desktop file(s) with a MimeType: entry.
     Note: desktop file(s) with MimeType entry in cloudcompare
[x]: gtk-update-icon-cache is invoked in %postun and %posttrans if package
     contains icons.
     Note: icons in cloudcompare
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or
     desktop-file-validate if there is such a file.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     cloudcompare-debuginfo
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[!]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
     Note: Arch-ed rpms have a total of 16056320 bytes in /usr/share
     cloudcompare-2.8.1-1.fc27.x86_64.rpm:16056320
     See:
     http://fedoraproject.org/wiki/Packaging:ReviewGuidelines#Package_Review_Guidelines
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.

Comment 2 Miro Hrončok 2017-09-11 12:13:47 UTC
Thanks for the feedback!

Comment 3 Miro Hrončok 2018-02-22 17:15:57 UTC
Let's get back to this :D

Spec URL: https://github.com/hroncok/cloudcompare/raw/master/cloudcompare.spec
SRPM URL: https://churchyard.fedorapeople.org/SRPMS/cloudcompare-2.9.1-1.fc27.src.rpm

(ETA 15 minutes to upload the SRPM, it's somehow slow.)

Changes in https://github.com/hroncok/cloudcompare/commits/master

F27 scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=25238489

I have some (most likely unrelated) deps issues in f28+ now.

Comment 4 Robert-André Mauchin 🐧 2018-02-22 21:21:01 UTC
 - These shouldn't have executable bits, it should be 0644:

cloudcompare-debugsource.x86_64: W: spurious-executable-perm /usr/src/debug/cloudcompare-2.9.1-1.fc27.x86_64/plugins/qHoughNormals/nanoflann/include/nanoflann.hpp
cloudcompare-debugsource.x86_64: W: spurious-executable-perm /usr/src/debug/cloudcompare-2.9.1-1.fc27.x86_64/plugins/qHoughNormals/normals_Hough/Normals.h

cloudcompare.src: W: strange-permission ccviewer.desktop 755
cloudcompare.src: W: strange-permission cloudcompare.desktop 755

   Fix it in prep for the first two and notify upstream. For the .desktop file make sure the file perm are 0644 when you build your SRPM.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "LGPL (v2 or later)", "GPL (v2 or later)", "GPL (v3 or later)",
     "Unknown or generated", "MIT/X11 (BSD like)", "Apache (v1.1)",
     "zlib/libpng", "LGPL", "GPL (v2) LGPL (v2 or later)", "BSD
     (unspecified)", "BSD (2 clause)", "LGPL (v2.1 or later)", "GPL (v2)",
     "LGPL (v2.1)". 865 files have unknown license. Detailed output of
     licensecheck in /home/bob/packaging/review/cloudcompare/review-
     cloudcompare/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 163840 bytes in 3 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or
     desktop-file-validate if there is such a file.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: cloudcompare-2.9.1-1.fc27.x86_64.rpm
          cloudcompare-doc-2.9.1-1.fc27.noarch.rpm
          cloudcompare-debuginfo-2.9.1-1.fc27.x86_64.rpm
          cloudcompare-debugsource-2.9.1-1.fc27.x86_64.rpm
          cloudcompare-2.9.1-1.fc27.src.rpm
cloudcompare.x86_64: W: spelling-error %description -l en_US octree -> trochee
cloudcompare.x86_64: W: spelling-error %description -l en_US resampling -> re sampling, re-sampling, oversampling
cloudcompare.x86_64: W: no-manual-page-for-binary CloudCompare
cloudcompare.x86_64: W: no-manual-page-for-binary ccViewer
cloudcompare.x86_64: W: no-manual-page-for-binary ccviewer
cloudcompare.x86_64: W: no-manual-page-for-binary cloudcompare
cloudcompare-debugsource.x86_64: W: no-documentation
cloudcompare-debugsource.x86_64: W: spurious-executable-perm /usr/src/debug/cloudcompare-2.9.1-1.fc27.x86_64/plugins/qHoughNormals/nanoflann/include/nanoflann.hpp
cloudcompare-debugsource.x86_64: W: spurious-executable-perm /usr/src/debug/cloudcompare-2.9.1-1.fc27.x86_64/plugins/qHoughNormals/normals_Hough/Normals.h
cloudcompare.src: W: spelling-error %description -l en_US octree -> trochee
cloudcompare.src: W: spelling-error %description -l en_US resampling -> re sampling, re-sampling, oversampling
cloudcompare.src: W: strange-permission ccviewer.desktop 755
cloudcompare.src: W: strange-permission cloudcompare.desktop 755
5 packages and 0 specfiles checked; 0 errors, 13 warnings.

Comment 5 Miro Hrončok 2018-02-22 23:48:44 UTC
(In reply to Robert-André Mauchin from comment #4)
>  - These shouldn't have executable bits, it should be 0644:
> 
> cloudcompare-debugsource.x86_64: W: spurious-executable-perm
> /usr/src/debug/cloudcompare-2.9.1-1.fc27.x86_64/plugins/qHoughNormals/
> nanoflann/include/nanoflann.hpp
> cloudcompare-debugsource.x86_64: W: spurious-executable-perm
> /usr/src/debug/cloudcompare-2.9.1-1.fc27.x86_64/plugins/qHoughNormals/
> normals_Hough/Normals.h

https://github.com/hroncok/cloudcompare/commit/d4e6e87c206637ccdecfbd689a47eda04f76f2cf

> cloudcompare.src: W: strange-permission ccviewer.desktop 755
> cloudcompare.src: W: strange-permission cloudcompare.desktop 755

https://github.com/hroncok/cloudcompare/commit/f00fca40c4062ded55f62727d4568654babc342b


Spec URL: https://github.com/hroncok/cloudcompare/raw/master/cloudcompare.spec
SRPM URL: https://churchyard.fedorapeople.org/SRPMS/cloudcompare-2.9.1-1.fc27.src.rpm

Again, the SRPM gets uploaded slowly, ETA ~15 minutes.

Comment 6 Robert-André Mauchin 🐧 2018-02-23 11:58:25 UTC
Seems good to me, package approved.

Comment 7 Miro Hrončok 2018-02-23 12:28:51 UTC
Thank you!

BTW Upstream is trying to fix the issues so this might not need the exclude BE arches after all.

Comment 8 Gwyn Ciesla 2018-02-23 13:35:12 UTC
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/cloudcompare

Comment 9 Fedora Update System 2018-02-24 20:32:49 UTC
cloudcompare-2.9.1-1.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-f008ca833c

Comment 10 Fedora Update System 2018-03-06 17:24:40 UTC
cloudcompare-2.9.1-1.fc27 has been pushed to the Fedora 27 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.